package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: QueryType
// UnionValue: ChainId

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("RequestByChainId")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RequestByChainId implements Marshallable {
	public final QueryType type = QueryType.CHAIN_ID;
	private byte[] chainId;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getChainId() {
	    return chainId;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setChainId(final byte[] value) {
	    this.chainId = value;
	}

	public RequestByChainId chainId(final byte[] value) {
	    setChainId(value);
	    return this;
	}
	public RequestByChainId chainId(final String value) {
		try {
			setChainId(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.chainId == null || this.chainId.length == 0)) {
            marshaller.writeHash(2, this.chainId);
        }
        return marshaller.array();
    }
}
